// BinEditDoc.cpp : implementation of the CBinEditDoc class
//

#include "stdafx.h"
#include "BinEdit.h"

#include "BinEditDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBinEditDoc

IMPLEMENT_DYNCREATE(CBinEditDoc, CDocument)

BEGIN_MESSAGE_MAP(CBinEditDoc, CDocument)
	//{{AFX_MSG_MAP(CBinEditDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBinEditDoc construction/destruction

CBinEditDoc::CBinEditDoc()
{
	file = NULL;
}

CBinEditDoc::~CBinEditDoc()
{
}

BOOL CBinEditDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}

void CBinEditDoc::GetData(int pos, unsigned char *data, int size)
{
	if (!file) return;
	file->Seek(pos, CFile::begin);
	file->Read(data, size);
}

int CBinEditDoc::GetFileSize()
{
	if (file) return file->GetLength();
	return 0;
}

void CBinEditDoc::WriteByte(int addr, char b)
{
	file->Seek(addr, CFile::begin);
	file->Write(&b, 1);
}

/////////////////////////////////////////////////////////////////////////////
// CBinEditDoc serialization

void CBinEditDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBinEditDoc diagnostics

#ifdef _DEBUG
void CBinEditDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBinEditDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBinEditDoc commands


BOOL CBinEditDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	CFile *f = new CFile(lpszPathName, CFile::modeReadWrite);
	DeleteContents();
	file = f;
	UpdateAllViews(NULL);
	return TRUE;
}

void CBinEditDoc::DeleteContents() 
{
	if (file)
	{
		file->Close();
		delete file;
		file = NULL;
	}
	
	CDocument::DeleteContents();
}
