// BinEditView.h : interface of the CBinEditView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_BINEDITVIEW_H__BAA21E4B_84ED_11D5_B5F3_5254AB134FE2__INCLUDED_)
#define AFX_BINEDITVIEW_H__BAA21E4B_84ED_11D5_B5F3_5254AB134FE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AddrDlg.h"
#include "SelectsymDlg.h"

const char hex_table[] = "0123456789ABCDEF";

class CBinEditView : public CView
{
protected: // create from serialization only
	CBinEditView();
	DECLARE_DYNCREATE(CBinEditView)

// Attributes
private:
	CAddrDlg m_AddrDlg;
	CSelectsymDlg m_SymDlg;
	CFont *pFont;
	bool m_Control;
	int m_nCharWidth;
	int m_nCharHeight;
	int m_nRows;
	int m_nCols;
	int m_nPageSize;
	int m_nPagePos;
	int m_nCursorPos;
	int m_nActivePane;
	int m_nSystem;
	int m_nNumWidth;
	int m_nFileSize;
	int m_nBufWidth;
	int m_nCodePage;
	unsigned char *codetable;
	unsigned char *data;
	unsigned char *textbuf;
	void NumberToText(unsigned char, unsigned char *);
	void MakeTextBuf();
	void CalcVars(int, int);
	void CheckVars();
	void MakeCaret();
	void SetCaret();
	void UpdateStatus();
	void SetSB();
	void SetSBPos();
	void SetSystem(int);
	void MakeFont(int);
	void BuildCodeTable(int);
	void ChangeCodePage(int);
	int SetMouseSel(CPoint);
public:
	CBinEditDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBinEditView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBinEditView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBinEditView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnUpdateBin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDec(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHex(CCmdUI* pCmdUI);
	afx_msg void OnUpdateOct(CCmdUI* pCmdUI);
	afx_msg void OnBin();
	afx_msg void OnDec();
	afx_msg void OnHex();
	afx_msg void OnOct();
	afx_msg void OnUpdateGotoaddr(CCmdUI* pCmdUI);
	afx_msg void OnGotoaddr();
	afx_msg void OnUpdateChangeval(CCmdUI* pCmdUI);
	afx_msg void OnChangeval();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnFontsize();
	afx_msg void OnUpdateDos(CCmdUI* pCmdUI);
	afx_msg void OnDos();
	afx_msg void OnUpdateWindows(CCmdUI* pCmdUI);
	afx_msg void OnWindows();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BinEditView.cpp
inline CBinEditDoc* CBinEditView::GetDocument()
   { return (CBinEditDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_BINEDITVIEW_H__BAA21E4B_84ED_11D5_B5F3_5254AB134FE2__INCLUDED_)
